from OFS import ZDOM

class Widget:
    def __init__(self, nodename):
        self.nodename = nodename
        
    def _isNodeSupported(self, node, REQUEST):
        """Check if node is supported by this widget.
        
        You may supply an 'isNodeSupported' method (without
        underscore) to do additional checks.
        """
        if node.getNodeName() == self.nodename:
            if hasattr(self, 'isNodeSupported'):
                return self.isNodeSupported(node, REQUEST)
            else:
                return 1

    def getElementNodes(self, parentnode):
        """Get all element nodes, ignoring all other kinds.
        """
        nodes = []
        for node in parentnode.getChildNodes():
            if node.getNodeType() == ZDOM.ELEMENT_NODE:
                nodes.append(node)
        return nodes

    def _inheritContext(self):
        return self
        
    def getWidgetURL(self, node):
        """Get the URL of this widget.
        """
        return node.absolute_url() + "/" + self.id

    def event(self, node, methodname):
        """Create an event URL for the widget applied to the node.
        """
        return self.getWidgetURL(node) + "/" + methodname
    




